﻿using DocumentFormat.OpenXml.Presentation;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Office.Core;
using Microsoft.Office.Interop.PowerPoint;
using System.Drawing.Drawing2D;
using Newtonsoft.Json.Linq;


namespace kintone2pptx2
{
    internal class powerpoint_lib
    {

        public void ReplaceText(JObject  ppt_data, string file1, string file2)
        {
            //Dictionary<string, string> dic = new Dictionary<string, string>();
            //dic["A2"] = "町田";
            //dic["D5"] = "狛江";
            //dic["B3"] = "相模大野";

            var pptApp = new Microsoft.Office.Interop.PowerPoint.Application();

            try
            {
                Microsoft.Office.Interop.PowerPoint.Presentation presentation = pptApp.Presentations.Open(file1, MsoTriState.msoFalse, MsoTriState.msoFalse, MsoTriState.msoFalse);

                foreach (Microsoft.Office.Interop.PowerPoint.Shape sp in presentation.Slides[1].Shapes)
                {
                    if (sp.HasTable == MsoTriState.msoTrue)
                    {
                        Table table = sp.Table;
                        // テーブルが見つかった場合の処理

                        for (int i = 1; i <= table.Rows.Count; i++)
                        {
                            for (int j = 1; j <= table.Columns.Count; j++)
                            {
                                var tgt = table.Cell(i, j).Shape.TextFrame.TextRange.Text;
                                foreach (var kv in ppt_data.Properties())
                                {
                                    if (tgt == kv.Name)
                                    {
                                        table.Cell(i, j).Shape.TextFrame.TextRange.Text = (string)kv.Value;
                                    }
                                }
                                Debug.WriteLine(tgt);
                            }
                        }

                        break; // すぐにループを終了する場合
                    }
                    Debug.WriteLine(sp.Name);
                }


                presentation.SaveAs(file2);
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"エラー: {ex.Message}");
            }
            finally
            {
                // PowerPointを終了
                ReleaseObject(pptApp);
            }

            // COMオブジェクトの解放を確認する
            GC.Collect();
            GC.WaitForPendingFinalizers();

        }


        private static void ReleaseObject(object obj)
        {
            try
            {
                Marshal.ReleaseComObject(obj);
                obj = null;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"COMオブジェクトの解放中にエラーが発生しました: {ex.Message}");
            }
        }




    }
}
