﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SQLite;
using Newtonsoft.Json.Linq;
using System.Diagnostics;

namespace kintone2pptx2
{
    internal class sqlite3_lib
    {
        //JArray arrFields = new JArray();


        public void CreateTable(JArray arrFields)
        {
            //JArray arrFields = new JArray();
            // arrFields.Add("id");
            // arrFields.Add("name");
            // arrFields.Add("住所");

            string table_name = "tbl3";

            SQLiteConnection con = new SQLiteConnection("Data Source=database.sqlite;Version=3;");
            con.Open();

            SQLiteCommand com = new SQLiteCommand($"drop table if exists {table_name}", con);
            com.ExecuteNonQuery();

            //con.EnableExtensions(true);
            try
            {
                string sql = $@"create table if not exists {table_name} (" + Environment.NewLine;

                int cnt = 0;
                foreach (var field in arrFields)
                {
                    if (cnt == 0)
                    {
                        sql += $@"{field} text" + Environment.NewLine;
                    }
                    else
                    {
                        sql += $@", {field} text" + Environment.NewLine;
                    }

                    cnt++;
                }
                sql += ")";

                //Debug.WriteLine(sql);

                //string sql = @"create table if not exists table_test1(" +
                //    "id integer primary key autoincrement," +
                //    "name text ," +
                //    "body text )";


                 com = new SQLiteCommand(sql, con);
                var sdr = com.ExecuteNonQuery();

            }
            finally
            {
                con.Close();
            }

        }

        private JArray ConvertJArrayToSimplifiedJArray(JArray jsonArray)
        {
            JArray simplifiedJsonArray = new JArray();

            foreach (var item in jsonArray)
            {
                JObject simplifiedItem = new JObject();

                foreach (JProperty property in item.Children<JProperty>())
                {
                    simplifiedItem[property.Name] = property.Value["value"];
                }

                simplifiedJsonArray.Add(simplifiedItem);
            }

            return simplifiedJsonArray;
        }


        public void insertData(JArray fields, JArray data)
        {


            string table_name = "tbl3";

            SQLiteConnection con = new SQLiteConnection("Data Source=database.sqlite;Version=3;");
            con.Open();
            SQLiteCommand com = new SQLiteCommand($"delete from {table_name}", con);
            com.ExecuteNonQuery();

            //Debug.WriteLine(data);
            var data2 = ConvertJArrayToSimplifiedJArray(data);

            foreach (JObject item in data2)
            {
                string fields_str = "";
                string values = "( ";
                foreach (string key in fields)
                {
                    string val = (string)item[key];
                    //Debug.WriteLine(prop.Name);
                    //Debug.WriteLine(prop.Value);
                    fields_str += key + ",";
                    values += $"\"{val}\",";
                }
                fields_str = fields_str.Substring(0, fields_str.Length - 1);
                values = values.Substring(0, values.Length - 1) + " )";
                //Debug.WriteLine(fields);
                //Debug.WriteLine(values);

                string sql = $@"insert into {table_name} ({fields_str}) values {values}";
                Debug.WriteLine(sql);

                com = new SQLiteCommand(sql, con);
                var sdr = com.ExecuteNonQuery();

            }
            con.Close();

        }



        public void selectData()
        {
            SQLiteConnection con = new SQLiteConnection("Data Source=database.sqlite;Version=3;");
            con.Open();
            con.EnableExtensions(true);
            try
            {
                string sql = "select * from tbl1";

                SQLiteCommand com = new SQLiteCommand(sql, con);
                SQLiteDataReader sdr = com.ExecuteReader();


                while (sdr.Read() == true)
                {
                    Console.WriteLine(sdr[0]);
                    Console.WriteLine(sdr[1]);

                }
                //Console.WriteLine(txt);
                sdr.Close();
            }
            finally
            {
                con.Close();
            }

        }

        public int selecOne(string sql)
        {
            int count = -1;

            SQLiteConnection con = new SQLiteConnection("Data Source=database.sqlite;Version=3;");
            con.Open();
            using (SQLiteCommand command = new SQLiteCommand(sql, con))
            {
                // クエリを実行し、結果のスカラー値を取得
                count = Convert.ToInt32(command.ExecuteScalar());

                //Console.WriteLine("レコードの件数: " + count);
            }

            return count;
        }
    }
}
